Index: trunk/kernel/mm/vmm.h
===================================================================
--- trunk/kernel/mm/vmm.h	(revision 690)
+++ trunk/kernel/mm/vmm.h	(revision 1)
@@ -3,6 +3,7 @@
  *
  * Authors   Ghassan Almaless (2008,2009,2010,2011, 2012)
- *           Alain Greiner    (2016,2017,2018,2019,2020))
- *
+ *           Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ * 
  * Copyright (c) UPMC Sorbonne Universites
  *
@@ -26,9 +27,9 @@
 #define _VMM_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <bits.h>
 #include <list.h>
-#include <queuelock.h>
-#include <remote_queuelock.h>
+#include <grdxt.h>
+#include <spinlock.h>
 #include <hal_gpt.h>
 #include <vseg.h>
@@ -38,56 +39,51 @@
 
 struct process_s;
-struct vseg_s;
-
-/*********************************************************************************************
- * This structure defines the STACK allocator used by the VMM to dynamically handle
- * vseg allocation or release requests for an user thread.
- * This allocator handles a fixed size array of fixed size slots in STACK zone of user space.
+
+/*********************************************************************************************
+ * This structure defines the STACK allocator used by the VMM to dynamically allocate
+ * STACK vsegs requested or released by the user process.
+ * This allocator handles a fixed size array of fixed size slots stores in the STACK zone.
  * The stack size and the number of slots are defined by the CONFIG_VMM_STACK_SIZE, and
- * CONFIG_VMM_STACK_BASE parameters.
- * Each slot can contain one user stack vseg. The first 4 Kbytes page in the slot is not
- * mapped to detect stack overflow.
- * In this implementation, the slot index is defined by the user thead LTID.
- * All allocated stacks are registered in a bitmap defining the STACK zone state: 
- * - The allocator checks that the requested slot has not been already allocated, and set the
- *   corresponding bit in the bitmap.
- * - The de-allocator reset the corresponding bit in the bitmap.
- *
- * An  architecture dependant hal_vmm_display() function is defined in <hal_vmm.h> file.
+ * CONFIG_THREAD
+ * Each slot can contain one user stack vseg. The first page in the slot is not allocated
+ * to detect stack overflow.
+ * The slot index can be computed form the slot base address, and reversely.
+ * All allocation / release operations are registered in the stack_bitmap, that completely
+ * define the STACK zone state.  
+ * In this implementation, the max number of slots is 32.
  ********************************************************************************************/
 
 typedef struct stack_mgr_s
 {
-    busylock_t     lock;               /*! lock protecting STACK allocator                  */
+    spinlock_t     lock;               /*! lock protecting STACK allocator                  */
     vpn_t          vpn_base;           /*! first page of STACK zone                         */
-    bitmap_t       bitmap;             /*! bit vector of allocated stacks                   */
+    bitmap_t       bitmap;             /*! bit bector of allocated stacks                   */
 }
 stack_mgr_t;
 
 /*********************************************************************************************
- * This structure defines the MMAP allocator used by the VMM to dynamically handle MMAP vsegs
- * requested or released by an user process. It must be called in the reference cluster.
- * - allocation policy : 
- *   This allocator implements the buddy algorithm. All allocated vsegs occupy an integer
- *   number of pages, that is power of 2, and are aligned (vpn_base is multiple of vpn_size).
- *   The requested number of pages is rounded if required. The global allocator state is
- *   completely defined by the free_pages_root[] array indexed by the vseg order.
- *   These free lists are local, but are implemented as xlist because we use the existing
- *   vseg.xlist to register a free vseg in its free list.
- * - release policy : 
- *   A released vseg is recursively merged with the "buddy" vseg when it is free, in
- *   order to build the largest possible aligned free vsegs. The resulting vseg.vpn_size
- *   field is updated.
- * Implementation note:
- * The only significant (and documented) fiels in the vsegs registered in the MMAP allocator
- * free lists are "xlist", "vpn_base", and "vpn_size".
+ * This structure defines the MMAP allocator used by the VMM to dynamically allocate
+ * MMAP vsegs requested or released by an user process.
+ * This allocator sould be only used in the reference cluster.
+ * - allocation policy : all allocated vsegs occupy an integer number of pages that is 
+ *   power of 2, and are aligned on a page boundary. The requested number of pages is
+ *   rounded if reqired. The first_free_vpn variable defines completely the MMAP zone state.
+ *   It is never decremented, as the released vsegs are simply registered in a zombi_list.
+ *   The relevant zombi_list is checked first for each allocation request. 
+ * - release policy : a released MMAP vseg is registered in an array of zombi_lists.
+ *   This array is indexed by ln(number of pages), and each entry contains the root of
+ *   a local list of zombi vsegs that have the same size. The physical memory allocated
+ *   for a zombi vseg descriptor is not released, to use the "list" field.
+ *   This physical memory allocated for MMAP vseg descriptors is actually released
+ *   when the VMM is destroyed.
  ********************************************************************************************/
 
 typedef struct mmap_mgr_s
 {
-    busylock_t     lock;               /*! lock protecting MMAP allocator                   */
+    spinlock_t     lock;               /*! lock protecting MMAP allocator                   */
     vpn_t          vpn_base;           /*! first page of MMAP zone                          */
     vpn_t          vpn_size;           /*! number of pages in MMAP zone                     */
-    xlist_entry_t  free_list_root[CONFIG_VMM_HEAP_MAX_ORDER + 1];  /* roots of free lists   */
+    vpn_t          first_free_vpn;     /*! first free page in MMAP zone                     */
+    list_entry_t   zombi_list[32];     /*! array of roots of released vsegs lists           */
 }
 mmap_mgr_t;
@@ -95,186 +91,80 @@
 /*********************************************************************************************
  * This structure defines the Virtual Memory Manager for a given process in a given cluster.
- * This VMM implements four main services:
- * 1) It contains the local copy of the vseg list (VSL), only complete in reference cluster.
- * 2) It contains the local copy of the generic page table (GPT), only complete in reference.
- * 3) The stack manager dynamically allocates virtual memory space for the STACK vsegs.
- * 4) The mmap manager dynamically allocates virtual memory for the (FILE/ANON/REMOTE) vsegs.
- ******************************************************a**************************************
- * Implementation notes:
- * 1. In most clusters, the VSL and GPT are only partial copies of the reference VSL and GPT
- *    structures, stored in the reference cluster.
- * 2. The VSL contains only local vsegs, but it is implemented as an xlist, and protected by
- *    a remote_rwlock, because it can be accessed by a thread running in a remote cluster.
- *    An example is the vmm_fork_copy() function.
- * 3. The GPT in the reference cluster can be directly accessed by remote threads to handle
- *    false page-fault (page is mapped in the reference GPT, but the PTE copy is missing
- *    in the local GPT). As each PTE can be protected by a specific GPT_LOCKED attribute
- *    for exclusive access, it is NOT protected by a global lock. 
+ * This local VMM provides three main services:
+ * 1) It registers all vsegs statically or dynamically defined in the vseg list,
+ *    and in the associated radix-tree.
+ * 2) It allocates virtual memory space for the STACKS and MMAP vsegs,
+ *    using dedicated allocators. 
+ * 3) It contains the local copy of the generic page table descriptor.
  ********************************************************************************************/
 
 typedef struct vmm_s
 {
-	remote_queuelock_t vsl_lock;            /*! lock protecting the local VSL               */
-	xlist_entry_t      vsegs_root;          /*! Virtual Segment List root                   */
-	uint32_t           vsegs_nr;            /*! total number of local vsegs                 */
-
-    gpt_t              gpt;                 /*! Generic Page Table descriptor               */
-
-    stack_mgr_t        stack_mgr;           /*! embedded STACK vsegs allocator              */
-
-    mmap_mgr_t         mmap_mgr;            /*! embedded MMAP vsegs allocator               */
-
-	uint32_t           false_pgfault_nr;    /*! false page fault counter (for all threads)  */
-	uint32_t           local_pgfault_nr;    /*! false page fault counter (for all threads)  */
-	uint32_t           global_pgfault_nr;   /*! false page fault counter (for all threads)  */
-    uint32_t           false_pgfault_cost;  /*! cumulated cost (for all threads)            */
-    uint32_t           local_pgfault_cost;  /*! cumulated cost (for all threads)            */
-    uint32_t           global_pgfault_cost; /*! cumulated cost (for all threads)            */
-
-    vpn_t              args_vpn_base;       /*! args vseg first page                        */
-    vpn_t              envs_vpn_base;       /*! envs vseg first page                        */
-	vpn_t              code_vpn_base;       /*! code vseg first page                        */
-	vpn_t              data_vpn_base;       /*! data vseg first page                        */
-    vpn_t              heap_vpn_base;       /*! heap zone first page                        */
-
-	intptr_t           entry_point;         /*! main thread entry point                     */
+	rwlock_t       vsegs_lock;         /*! lock protecting the vsegs list & radix tree      */
+	list_entry_t   vsegs_root;         /*! all vsegs in same process and same cluster       */
+	uint32_t       vsegs_nr;           /*! total number of vsegs                            */
+
+  	grdxt_t        grdxt;              /*! embedded generic vsegs radix tree (key is vpn)   */
+
+    gpt_t          gpt;                /*! embedded generic page table descriptor           */
+
+    stack_mgr_t    stack_mgr;          /*! embedded STACK vsegs allocator                   */
+
+    mmap_mgr_t     mmap_mgr;           /*! embedded MMAP vsegs allocator                    */
+
+	uint32_t       pgfault_nr;         /*! page fault counter                               */
+	uint32_t       u_err_nr;           /*! TODO ??? [AG]                                    */
+	uint32_t       m_err_nr;           /*! TODO ??? [AG]                                    */
+
+    vpn_t          kent_vpn_base;      /*! kentry vseg first page                           */
+    vpn_t          args_vpn_base;      /*! args vseg first page                             */
+    vpn_t          envs_vpn_base;      /*! envs zone first page                             */
+    vpn_t          heap_vpn_base;      /*! envs zone first page                             */
+	vpn_t          code_vpn_base;      /*! code zone first page                             */
+	vpn_t          data_vpn_base;      /*! data zone first page                             */
+
+	intptr_t       entry_point;        /*! main thread entry point                          */
+
+    vseg_t       * heap_vseg;          /*! pointer on local heap vseg descriptor            */
 }
 vmm_t;
 
 /*********************************************************************************************
- * This function makes a partial initialisation of the VMM attached to an user process.
- * It intializes the STACK and MMAP allocators, the VSL lock, and the instrumentation
- * counters, but it does not register any vseg in the VSL:
- * - The "kernel" vsegs are registered, by the hal_vmm_kernel_update() function.
- * - The "args" & "envs" vsegs are registered by the process_make_exec() function.
- * - The "code" and "data" vsegs are registered by the elf_load_process() function.
- * - The "stack" vsegs are registered by process_make_exec() / thread_user_create().
- * - The "file", "anon", "remote" vsegs are dynamically registered by the mmap() syscall.
+ * This structure is used to store the arguments of the mmap() system call.
+ ********************************************************************************************/
+
+typedef struct mmap_attr_s
+{
+	void     * addr;            /*! requested virtual address (unused : should be NULL)     */ 
+	uint32_t   length;          /*! requested vseg size (bytes)                             */
+	uint32_t   prot;            /*! access modes                                            */
+	uint32_t   flags;           /*! only MAP_FILE / MAP_ANON / MAP_PRIVATE / MAP_SHARED     */
+	fdid_t     fdid;            /*! file descriptor index (if MAP_FILE is set)              */
+	int32_t    offset;          /*! file offset (if MAP_FILE is set)                        */
+}
+mmap_attr_t;
+
+/*********************************************************************************************
+ * This function initialises the virtual memory manager attached to a process.
+ * - It initializes the VSL (list of vsegs and associated radix tree).
+ * - It initializes the generic page table (empty).
+ * - It initializes the STAK and MMAP allocators.
+ * - It registers the "kentry", "args", "envs" and "heap" vsegs in the vsegs list.
+ * Any error in this function gives a kernel panic.
  *********************************************************************************************
  * @ process   : pointer on process descriptor
- * @ return 0 if success / return -1 if failure.
- ********************************************************************************************/
-error_t vmm_user_init( struct process_s * process );
-
-/*********************************************************************************************
- * This function is called by the process_make_exec() function to re-initialises the VMM
- * attached to an user process:
- * - It removes from the VMM of the process identified by the <process> argument all user
- *   vsegs, by calling the vmm_remove_vseg() function: the vsegs are removed from the VSL,
- *   the corresponding GPT entries are removed from the GPT, and the physical pages are 
- *   released to the relevant kmem when they are not shared.
- * - The VSL and the GPT are not modified for the kernel vsegs.
- * - Finally, it calls the vmm_user_init() function to re-initialize the STAK and MMAP
- *   allocators, and the lock protecting GPT.
- *********************************************************************************************
- * @ process   : pointer on process descriptor.
- ********************************************************************************************/
-void vmm_user_reset( struct process_s * process );
-
-/*********************************************************************************************
- * This function is called by the process_make_fork() function. It partially copies
- * the content of a remote parent process VMM to the local child process VMM:
- * - The KERNEL vsegs required by the architecture must have been previously
- *   created in the child VMM, using the hal_vmm_kernel_update() function.
- * - The DATA, ANON, REMOTE vsegs registered in the parent VSL are registered in the
- *   child VSL. All valid PTEs in parent GPT are copied to the child GPT.
- *   The WRITABLE  and COW flags are not modified, as it will be done later for those
- *   shared pages by the vmm_set_cow() function.
- * - The CODE vsegs registered in the parent VSL are registered in the child VSL, but the
- *   GPT entries are not copied in the child GPT, and will be dynamically updated from
- *   the .elf file when a page fault is reported.
- * - The FILE vsegs registered in the parent VSL are registered in the child VSL, and all
- *   valid GPT entries in parent GPT are copied to the child GPT. The COW flag is not set.
- * - No STACK vseg is copied from  parent VMM to child VMM: the child stack vseg is copied
- *   later from the cluster containing the user thread requesting the fork().
- *********************************************************************************************
- * @ child_process     : local pointer on local child process descriptor.
- * @ parent_process_xp : extended pointer on remote parent process descriptor.
- * @ return 0 if success / return -1 if failure.
- ********************************************************************************************/
-error_t vmm_fork_copy( struct process_s * child_process,
-                       xptr_t             parent_process_xp );
-
-/*********************************************************************************************
- * This function is called by the process_make_fork() function to update the COW attribute
- * in the parent parent process vsegs. It set the COW flag, and reset the WRITABLE flag of
- * all GPT entries of the DATA, MMAP, and REMOTE vsegs of the <process> argument.
- * It must be called by a thread running in the reference cluster, that contains the complete
- * VSL and GPT (use the rpc_vmm_set_cow_client() when the calling thread client is remote). 
- * It updates all copies of the process in all clusters, to maintain coherence in GPT copies,
- * using the list of copies stored in the owner process, and using remote_write accesses to
- * update the remote GPTs. It atomically increment the pending_fork counter, in all involved
- * physical page descriptors. It cannot fail, as only mapped entries in GPTs are updated.
- *********************************************************************************************
- * @ process   : local pointer on local reference process descriptor.
- ********************************************************************************************/
-void vmm_set_cow( struct process_s * process );
-
-/*********************************************************************************************
- * This function modifies the vseg identified by <process> and <base> arguments in all
- * clusters containing a VSL copy, as defined by <new_base> and <new_size> arguments.
- * The new vseg, defined by the <new_base> and <new_size> arguments must be included
- * in the existing vseg. The target VSL size and base fields are modified in the VSL.
- * This is done in all clusters containing a VMM copy to maintain VMM coherence. 
- * It is called by the sys_munmap() and dev_fbf_resize_window() functions.
- * It can be called by a thread running in any cluster, as it uses the vmm_resize_vseg() in
- * the local cluster, and parallel RPC_VMM_RESIZE_VSEG for remote clusters.
- * It cannot fail, as only vseg registered  in VSL copies are updated.
- *********************************************************************************************
- * @ process   : local pointer on process descriptor.
- * @ base      : current vseg base address in user space.
- * @ new_base  : new vseg base.
- * @ new_size  : new vseg size.
- ********************************************************************************************/
-void vmm_global_resize_vseg( struct process_s * process,
-                             intptr_t           base,
-                             intptr_t           new_base,
-                             intptr_t           new_size );
-
-/*********************************************************************************************
- * This function removes the vseg identified by the <process> and <base> arguments from
- * the VSL and remove all associated PTE entries from the GPT.
- * This is done in all clusters containing a VMM copy to maintain VMM coherence. 
- * It is called by the sys_munmap() and dev_fbf_resize_window() functions.
- * It can be called by a thread running in any cluster, as it uses the vmm_remove_vseg() in
- * the local cluster, and parallel RPC_VMM_REMOVE_VSEG for remote clusters.
- * It cannot fail, as only vseg registered  in VSL copies are deleted.
- *********************************************************************************************
- * @ pid      : local pointer on process identifier.
- * @ base     : vseg base address in user space.
- ********************************************************************************************/
-void vmm_global_delete_vseg( struct process_s * process,
-                             intptr_t           base );
-
-/*********************************************************************************************
- * This function modifies one GPT entry identified by the <process> and <vpn> arguments
- * in all clusters containing a process copy. It maintains coherence in GPT copies,
- * using remote_write accesses.
- * It cannot fail, as only mapped PTE2 in GPT copies are updated.
- *********************************************************************************************
- * @ process   : local pointer on local process descriptor.
- * @ vpn       : PTE index.
- * @ attr      : PTE / attributes.
- * @ ppn       : PTE / physical page index.
- ********************************************************************************************/
-void vmm_global_update_pte( struct process_s * process,
-                            vpn_t              vpn,
-                            uint32_t           attr,
-                            ppn_t              ppn );
-
-/*********************************************************************************************
- * This function deletes, in the local cluster, all vsegs registered in the VSL
- * of the process identified by the <process> argument. For each vseg:
- * - it unmaps all vseg PTEs from the GPT (release the physical pages when required). 
- * - it removes the vseg from the local VSL.
- * - it releases the memory allocated to the local vseg descriptors.
- * - it releases the memory allocated to the GPT itself.
- *********************************************************************************************
- * @ process   : pointer on process descriptor.
+ ********************************************************************************************/
+void vmm_init( struct process_s * process );
+
+/*********************************************************************************************
+ * This function removes all vsegs registered in in a virtual memory manager,
+ * and releases the memory allocated to the local generic page table. 
+ *********************************************************************************************
+ * @ vmm   : pointer on process descriptor.
  ********************************************************************************************/
 void vmm_destroy( struct process_s * process );
 
 /*********************************************************************************************
- * This function scans the list of vsegs registered in the VMM of a given process descriptor
+ * This function scan the list of vsegs registered in the VMM of a given process descriptor
  * to check if a given virtual region (defined by a base and size) overlap an existing vseg.
  *********************************************************************************************
